//Required
/////////////////////////////////////////////////////////////////
var gulp = require('gulp'),
    sass = require('gulp-sass'),
    cssnano = require('gulp-cssnano'),
    sourcemaps = require('gulp-sourcemaps'),
    autoprefixer = require('gulp-autoprefixer'),
    plumber = require('gulp-plumber'),
    uglify = require ('gulp-uglify'),
    rename = require ('gulp-rename');


//Compile Sass
/////////////////////////////////////////////////////////////////
gulp.task('sass', function() {
  // Create a stream in the directory where our Sass files are located.
    return gulp.src('sass/style.scss')
    .pipe(plumber({
      errorHandler: function (error) {
        console.log(error.message);
        this.emit('end');
    }}))
    .pipe(sourcemaps.init())
    .pipe(sass({
      style: 'compressed'
    }))
    // Minify and optimize style.css
    .pipe(cssnano())
    .pipe(sourcemaps.write())
    .pipe(autoprefixer({
            browsers: ['last 2 versions'],
            cascade: false
        }))
    // Write style.css to the project's root directory.
    .pipe(gulp.dest('public/css'));
});


//Watch Task
/////////////////////////////////////////////////////////////////
gulp.task('watch', function(){
  gulp.watch('components/**/*.scss', ['sass']);
});

//Default task
/////////////////////////////////////////////////////////////////
gulp.task('default', ['sass', 'watch']);






// //Required
// /////////////////////////////////////////////////////////////////
//
// var gulp = require ('gulp'),
//     uglify = require ('gulp-uglify'),
//     rename = require ('gulp-rename'),
//     sass = require ('gulp-sass');
//
//
// //Script Task
// /////////////////////////////////////////////////////////////////
//
// gulp.task ('scripts', function (){
//   gulp.src(['components/**/*.js', '!components/**/*/min.js'])
//   .pipe(rename({suffix:'.min'}))
//   .pipe(uglify())
//   .pipe(gulp.dest('public/js'));
// });
//
// //Sass Task
// /////////////////////////////////////////////////////////////////
// gulp.task('sass', function(){
//   gulp.src('sass/style.scss')
//   .pipe(gulp.dest('public/css'));
// });
//
// //Watch Task
// /////////////////////////////////////////////////////////////////
// gulp.task('watch', function(){
//   gulp.watch('components/**/*.js', ['scripts']);
//   gulp.watch('sass/*.scss', ['sass']);
// });
//
// //Default task
// /////////////////////////////////////////////////////////////////
// gulp.task('default', ['scripts', 'sass', 'watch']);
